
var RE = {};

RE.currentSelection = {
    "startContainer": 0,
    "startOffset": 0,
    "endContainer": 0,
    "endOffset": 0};

RE.editor = document.getElementById('editor');

RE.font_type=100;//默认字体100

RE.currencyNumber=1;
RE.one_page_height=0;
RE.last_innerHtml="";


document.addEventListener("selectionchange", function() {
    RE.select_change();
});

RE.select_change = function(){
    RE.backuprange();
    RE.get_currency_tag_list();
    if(RE.one_page_height!=0)
    RE.calNumberPage();
    RE.get_html_txt();
}
// Initializations
//RE.callback = function() {
//    window.location.href = "re-callback://" + encodeURIComponent(RE.getHtml());
//}

RE.setHtml = function(contents) {
    RE.editor.innerHTML = decodeURIComponent(contents.replace(/\+/g, '%20'));
    RE.check_load_status();
};

RE.check_load_status = function(){
    var timer = setInterval(function() {
        if (RE.is_load_finish()) {
            clearInterval(timer);
            RE.request_java_method("readyStateComplete","readyStateComplete");
        }
    }, 50)
};

//判断是否加载完成
RE.is_load_finish = function(){
    var img_es=document.getElementsByTagName("img");
    var len=img_es.length;
    for(var i=0;i<len;i++){
        var img=img_es[i];
        if (!img.complete) {
            return false;
        }
    }
    return true;
};


RE.getHtml = function() {
    return RE.editor.innerHTML;
    //window.jsCallJavaObj.java_method("getHtml",RE.editor.innerHTML);
}

RE.getText = function() {
    return RE.editor.innerText;
     // window.jsCallJavaObj.java_method("getText",RE.editor.innerText);
}

RE.setBaseTextColor = function(color) {
    RE.editor.style.color  = color;
    RE.select_change();
}

RE.setBaseFontSize = function(size) {
    RE.editor.style.fontSize = size;
    RE.select_change();
}

RE.setPadding = function(left, top, right, bottom) {
  RE.editor.style.paddingLeft = left;
  RE.editor.style.paddingTop = top;
  RE.editor.style.paddingRight = right;
  RE.editor.style.paddingBottom = bottom;
}

RE.setBackgroundColor = function(color) {
    document.body.style.backgroundColor = color;
}
//设置字体
RE.setBodyFont = function(font_type){
    if(font_type==="0")return;
    document.body.style.fontFamily="myFont"+font_type;
    RE.font_type=font_type;
}

RE.setBackgroundImage = function(image) {
    RE.editor.style.backgroundImage = image;
}

RE.removeBackgroundImage = function(){
    RE.editor.style.backgroundImage = null;
}

RE.setWidth = function(size) {
    RE.editor.style.minWidth = size;
}

RE.setHeight = function(size) {
    RE.editor.style.height = size;
}

RE.setTextAlign = function(align) {
    RE.editor.style.textAlign = align;
}

RE.setVerticalAlign = function(align) {
    RE.editor.style.verticalAlign = align;
}

RE.setPlaceholder = function(placeholder) {
    RE.editor.setAttribute("placeholder", placeholder);
}

RE.setInputEnabled = function(inputEnabled) {
    RE.editor.contentEditable = String(inputEnabled);
}

RE.undo = function() {
    document.execCommand('undo', false, null);
}

RE.redo = function() {
    document.execCommand('redo', false, null);
}

RE.setBold = function() {
    document.execCommand('bold', false, null);
    RE.select_change();
}



RE.setItalic = function() {
    document.execCommand('italic', false, null);
    RE.select_change();
}

RE.setSubscript = function() {
    document.execCommand('subscript', false, null);
}

RE.setSuperscript = function() {
    document.execCommand('superscript', false, null);
}

RE.setStrikeThrough = function() {
    document.execCommand('strikeThrough', false, null);
}

RE.setUnderline = function() {
    document.execCommand('underline', false, null);
    RE.select_change();
}

RE.insertUnorderedList = function() {
    document.execCommand('insertUnorderedList', false, null);
}

RE.insertOrderedList = function() {
    document.execCommand('insertOrderedList', false, null);
}

RE.setTextColor = function(color) {
    RE.restorerange();
    document.execCommand("styleWithCSS", null, true);
    document.execCommand('foreColor', false, color);
    document.execCommand("styleWithCSS", null, false);
    RE.select_change();
}

RE.setTextBackgroundColor = function(color) {
    RE.restorerange();
    document.execCommand("styleWithCSS", null, true);
    document.execCommand('hiliteColor', false, color);
    document.execCommand("styleWithCSS", null, false);
}

RE.setFontSize = function(fontSize){
    document.execCommand("fontSize", false, fontSize);
    RE.select_change();
}

RE.setHeading = function(heading) {
    document.execCommand('formatBlock', false, '<h'+heading+'>');
}

RE.setIndent = function() {
    document.execCommand('indent', false, null);
}

RE.setOutdent = function() {
    document.execCommand('outdent', false, null);
}

RE.setJustifyLeft = function() {
    document.execCommand('justifyLeft', false, null);
    RE.select_change();
}

RE.setJustifyCenter = function() {
    document.execCommand('justifyCenter', false, null);
    RE.select_change();
}

RE.setJustifyRight = function() {
    document.execCommand('justifyRight', false, null);
    RE.select_change();
}

RE.setBlockquote = function() {
    document.execCommand('formatBlock', false, '<blockquote>');
}

RE.insertImage = function(url, alt) {
    var html = '<img src="' + url + '" alt="' + alt + '" />';
    RE.insertHTML(html);
}

RE.insertImageW = function(url, alt, width) {
    var html = '<img src="' + url + '"  style="width:' + width + 'px;"/>';
    RE.insertHTML(html);
}

RE.insertImageWH = function(url, alt, width, height) {
    var html = '<img src="' + url + '" alt="' + alt + '" width="' + width + '" height="' + height +'"/>';
    RE.insertHTML(html);
}

RE.insertVideo = function(url, alt) {
    var html = '<video src="' + url + '" controls></video><br>';
    RE.insertHTML(html);
}

RE.insertVideoW = function(url, width) {
    var html = '<video src="' + url + '" width="' + width + '" controls></video><br>';
    RE.insertHTML(html);
}

RE.insertVideoWH = function(url, width, height) {
    var html = '<video src="' + url + '" width="' + width + '" height="' + height + '" controls></video><br>';
    RE.insertHTML(html);
}

RE.insertAudio = function(url, alt) {
    var html = '<audio src="' + url + '" controls></audio><br>';
    RE.insertHTML(html);
}





RE.insertHTML = function(html) {
    RE.restorerange();
    document.execCommand('insertHTML', false, html);
}



RE.setTodo = function(text) {
    var html = '<input type="checkbox" name="'+ text +'" value="'+ text +'"/> &nbsp;';
    document.execCommand('insertHTML', false, html);
}

RE.prepareInsert = function() {
    RE.backuprange();
}

RE.backuprange = function(){
    var selection = window.getSelection();
    if (selection.rangeCount > 0) {
      var range = selection.getRangeAt(0);
      RE.currentSelection = {
          "startContainer": range.startContainer,
          "startOffset": range.startOffset,
          "endContainer": range.endContainer,
          "endOffset": range.endOffset};
    }
}

RE.restorerange = function(){
    var selection = window.getSelection();
    selection.removeAllRanges();
    var range = document.createRange();
    range.setStart(RE.currentSelection.startContainer, RE.currentSelection.startOffset);
    range.setEnd(RE.currentSelection.endContainer, RE.currentSelection.endOffset);
    selection.addRange(range);
}

RE.enabledEditingItems = function(e) {
    var items = [];
    if (document.queryCommandState('bold')) {
        items.push('bold');
    }
    if (document.queryCommandState('italic')) {
        items.push('italic');
    }
    if (document.queryCommandState('subscript')) {
        items.push('subscript');
    }
    if (document.queryCommandState('superscript')) {
        items.push('superscript');
    }
    if (document.queryCommandState('strikeThrough')) {
        items.push('strikeThrough');
    }
    if (document.queryCommandState('underline')) {
        items.push('underline');
    }
    if (document.queryCommandState('insertOrderedList')) {
        items.push('orderedList');
    }
    if (document.queryCommandState('insertUnorderedList')) {
        items.push('unorderedList');
    }
    if (document.queryCommandState('justifyCenter')) {
        items.push('justifyCenter');
    }
    if (document.queryCommandState('justifyFull')) {
        items.push('justifyFull');
    }
    if (document.queryCommandState('justifyLeft')) {
        items.push('justifyLeft');
    }
    if (document.queryCommandState('justifyRight')) {
        items.push('justifyRight');
    }
    if (document.queryCommandState('insertHorizontalRule')) {
        items.push('horizontalRule');
    }
    var formatBlock = document.queryCommandValue('formatBlock');
    if (formatBlock.length > 0) {
        items.push(formatBlock);
    }

    window.location.href = "re-state://" + encodeURI(items.join(','));
}

RE.focus = function() {
    var range = document.createRange();
    range.selectNodeContents(RE.editor);
    range.collapse(false);
    var selection = window.getSelection();
    selection.removeAllRanges();
    selection.addRange(range);
    RE.editor.focus();
}




RE.blurFocus = function() {
    RE.editor.blur();
}

RE.removeFormat = function() {
    document.execCommand('removeFormat', false, null);
}



// Event Listeners
// RE.editor.addEventListener("input", RE.input_envent);
//RE.editor.addEventListener("keyup", function(e) {
//    var KEY_LEFT = 37, KEY_RIGHT = 39;
//    if (e.which == KEY_LEFT || e.which == KEY_RIGHT) {
//        RE.enabledEditingItems(e);
//    }
//});
//RE.editor.addEventListener("click", RE.enabledEditingItems);




// 自定义
//调用 java 方法
RE.request_java_method = function(method_name,paras){
     window.jsCallJavaObj.java_method(method_name,paras);
};

//所有img 增加点击事件
RE.add_img_click_look_event =function() {
    var img_es = document.getElementById("editor").getElementsByTagName("img")
    for (var i = 0; i < img_es.length; i++) {
        img_es[i].onclick= function (e){
            var src=e.target.src;
            RE.request_java_method("look_img",src);
        };
    }
};


//所有img 增加点击事件
RE.add_img_click_change_event =function() {
    var img_es = document.getElementById("editor").getElementsByTagName("img")
    for (var i = 0; i < img_es.length; i++) {
        img_es[i].onclick= function (e){
             var tmp=new Object();
                tmp.src=e.target.src;
                tmp.width=e.target.style.width;
                var info=JSON.stringify(tmp);
            RE.request_java_method("change_img",info);
        };
    }
};


//设置 img 宽度 src 是 img 标签下的 src width 单位是px
RE.set_img_src_to_width = function (src,width) {
    var img_es = document.getElementById("editor").getElementsByTagName("img")
    for (var i = 0; i < img_es.length; i++) {
        var src_currency=img_es[i].src;
        if(src_currency==src){
        if(img_es[i].style.width!=width)
            img_es[i].style.width=width;
            break;
        }
    }
}


//设置 editor 的状态  hidden,visible,是否显示
RE.set_show_status = function(status){
    RE.editor.style.visibility  = status;
}

//获取当前标签情况
RE.get_currency_tag_list = function(){
    var items = RE.currentSelection.endOffset+";";
    //endi_select

   //加粗
    if (document.queryCommandState('bold')) {
        items=items+'bold'+";";
    }

    //下划线
    if (document.queryCommandState('underline')) {
             items=items+'underline'+";";
    }
    //左对齐
    if (document.queryCommandState('justifyLeft')) {
             items=items+'justifyLeft'+";";
    }
    //居中
    if (document.queryCommandState('justifyCenter')) {
             items=items+'justifyCenter'+";";
    }
    //右对齐
    if (document.queryCommandState('justifyRight')) {
             items=items+'justifyRight'+";";
    }

    //前景色
    items=items+"foreColor="+document.queryCommandValue('foreColor')+";";


    RE.request_java_method("select_change",items);
}

//返回html内容,用于保存历史记录
RE.get_html_txt = function(){
 RE.request_java_method("get_html_txt",RE.getHtml());
}

//获取高度
RE.get_line_height = function(){
    var select_node_first=RE.get_select_node_first()
    if(select_node_first==undefined)return '1.0';
    if(select_node_first.style!=undefined){
        if(select_node_first.style.lineHeight!=undefined)return select_node_first.style.lineHeight;
    }
    return '1.0';
}


//获取当前选中的节点
RE.get_select_node_first = function(){
    var selectionObj = window.getSelection();
    if(selectionObj.anchorNode==null){
        return undefined;//没有焦点
    }
    var rangeObj = selectionObj.getRangeAt(0);
    var startNode=rangeObj.startContainer;
    if(startNode.style!=undefined){//是一个对象
        return startNode.childNodes.item(rangeObj.startOffset);
    }
    return startNode.parentElement;//返回父对象
}



//获取所有img 标签
RE.get_all_img_src = function () {
    var img_str_es="";
    var img_es = document.getElementById("editor").getElementsByTagName("img")
    for (var i = 0; i < img_es.length; i++) {
        var src_currency=img_es[i].src;
        img_str_es=img_str_es+src_currency+";"
    }
    return img_str_es;
}


//获取 html text  all_img_src
RE.get_html_text_all_img_src = function(){
    var tmp={};
    tmp.all_img_src=RE.get_all_img_src();
    tmp.html=RE.getHtml();
    tmp.number=RE.currencyNumber;
    tmp.txt=RE.getText();


    var info=JSON.stringify(tmp);

    RE.request_java_method("get_html_text_all_img_src",info);

}


//获取 选择的所有节点
RE.get_all_select_node = function(startNode,endNode){
    var array_list=[];
    RE.get_all_node(RE.editor,array_list);
    var result_list=[];
    var is_start=false;
    for(var i=0;i<array_list.length;i++){
        if(startNode==array_list[i])is_start=true;
        if(is_start)result_list.push(array_list[i]);
        if(endNode==array_list[i])break;
    }
    return result_list;
}

//获取所有节点
RE.get_all_node = function(parentNode,array_list){
    var total=parentNode.childNodes.length;
    for(var i=0;i<total;i++){
        array_list.push(parentNode.childNodes.item(i));
        RE.get_all_node(parentNode.childNodes.item(i),array_list);
    }
}


//设置行高  10px
RE.set_line_height = function(height){
    RE.editor.style.lineHeight=height;
}



//设置一页的高度
RE.set_one_page_height = function(height){
    RE.editor.style.minHeight=height;
    RE.one_page_height=height.replace("px","");
}
//设置页码数
RE.setNumberPager = function(numberPager){
    RE.currencyNumber=numberPager;
    var max_height=RE.currencyNumber*RE.one_page_height;
    RE.editor.style.minHeight=max_height+"px";
}


//计算页码
RE.calNumberPage = function(){
    var innerHTML=RE.editor.innerHTML;
    if(innerHTML==RE.last_innerHtml)return;

    RE.last_innerHtml=innerHTML;
    var realHeight = RE.get_real_height();
    if(realHeight==0)realHeight=18;

   // console.log("高度："+realHeight);
    var numberNeed=Math.ceil(realHeight/RE.one_page_height);
    if(numberNeed!=RE.currencyNumber){
        var max_height=numberNeed*RE.one_page_height;
        RE.editor.style.minHeight=max_height+"px";
        RE.currencyNumber=numberNeed;
    }
}


//获取 真实高度（最后一个内容的 总高度)
RE.get_real_height = function(){
    var last=RE.editor.lastChild;

    if(last==null)return 18;
    var currency_height=last.offsetHeight;
    if(currency_height==undefined){
        //非正常节点，需要通过选择获取高度

        var range = document.createRange();
        range.selectNodeContents(last);
        var rects = range.getClientRects();

        return rects[rects.length-1].bottom;
    }

    return last.offsetTop+currency_height;
}


RE.get_html_info = function(){
    var total=RE.editor.childNodes.length;
    var htmlNode={};
    htmlNode.child=[];
    for(var i=0;i<total;i++){
        RE.get_html_bean(RE.editor.childNodes[i],htmlNode,i);
    }
   return htmlNode;
};

RE.get_html_bean = function(html_target,parent_target_object){
    var object={};
    var nodeName=html_target.nodeName;
    object.tag=nodeName;
    switch (nodeName) {
        case "DIV":
            object.textAlign = html_target.style.textAlign;//对齐方式
            object.child=[];
            break;
        case "P":
        case "FONT":
            object.color = html_target.color;//颜色
            object.child=[];
            break;
        case "B":
            object.bold = "1";//加粗
            object.child=[];
            break;
        case "U":
            object.under = "1";//下划线
            object.child=[];
            break;
        case "#text"://文本
            object.text = html_target.textContent;
            break;
        case "SPAN":
            object.fontWeight=html_target.style.fontWeight;
            object.color = html_target.style.color;//颜色
            object.child=[];
            break;
        case "IMG":
            object.src=html_target.src;
            object.width=html_target.style.width;
            object.child=[];
            break;
        default:
            object.child=[];
    }
    parent_target_object.child.push(object);

    if(html_target.childNodes.length!==0){
        for(var j=0;j<html_target.childNodes.length;j++){
            RE.get_html_bean(html_target.childNodes[j],object);
        }
    }
};










$ = function (id_class_tag) {
    if(id_class_tag.indexOf(".")!=-1){
        return document.getElementsByClassName(id_class_tag.replace(".",""));
    }
    if(id_class_tag.indexOf("#")!=-1){
        return document.getElementById(id_class_tag.replace("#",""));
    }
    return document.getElementsByTagName(id_class_tag);
}